/*
 * File:   __GP22LoRa_RTCC_APP_C
 * Author:
 *
 * Created on2017-7-24
 */

#ifdef	__cplusplus
extern "C"
{
#endif

#include "type.h"
#include "UWater_rtcc_driver.h"
#include "UWater_power_app.h"
#include "UWater_eeprom_driver.h"
#include "UWater_valve_driver.h"
#include "UWater_timer1uS_driver.h"

#include "UWater_rtcc_app.h"
#include "UWater_frame_app.h"
#include "UWater_lcd_app.h"
#include "UWater_gp22_app.h"
#include "UWater_valve_app.h"
#include "UWater_DataTools_App.h"
//#include "sys_processor.h"
#include "UWater_pt_app.h"
	
	

//static RTCC_EE_DATA ee_data; //RTCC
 RTCC_HISTORY_DATA ee_history_data; //ʷݵԪ

 u8 miji_collect_buf[384];//ܼɼݴĴ
static u8 miji_collect_send_buf[192];//ܼɼӿ
RTCC_To_Float old_total_flow;//5minۻֵ
RTCC_To_Float new_total_flow;//5minۼֵ
RTCC_UNION_2U8TOU16 miji_date;
static u16 date_remember = 0;
RTCC_To_Float temp_to_gloat;//תר
RTCC_UNION_2U8TOU16 jiange_date;
//static u16 pulse_day_max_flow_time_temp;
//static u32 old_total_speed = 0;
//static u32 new_total_speed = 0;
//static u8 date_flag = 0;
static u8 s_g_rtcc_is_error = 0; //2015-6-3 Ĭ
static u8 s_g_rtcc_msg = 0; //2015-6-3
//static float s_daily_temprature[3];
//static u16 s_daily_temprature_min_max[2];

/*****************************/
u8 RtccIsError()
{
	if((RTC_ClkSource()==1)||(s_g_rtcc_is_error == 1))
	{
		return 1;
	}
	return 0;
}

void RtccClearError(void)
{
    s_g_rtcc_is_error = 0;
}
/*************************************************
Functionvoid RtccInitApp()
DescriptionRTCC INIT
Inputvoid
Outputvoid
Returnvoid
Others:
 *************************************************/


/*************************************************
Functionu8 RtccCheckMsgApp(void)
DescriptionѯǰǷڻԾ״̬ÿһСʱжһεĽӿڣݴ
Input
Outputbit0߻Ծ״̬ÿһСʱжһεĽӿڣ
bit1ݴԾ״̬ÿһСʱжһεĽӿڣ
bit2ʱʱ䵽MSGѯӿ 1ʱʱ䵽0δ
bit3Զݴʱ䵽MSG
bit4: УʱڵݴԾmsg
bit5: ˳ŵMSG

Returnvoid
Others:
 *************************************************/
u8 RtccCheckMsgApp(Rtcc_MsgTypeDef msg_bit)
{
    return (s_g_rtcc_msg & (1 << msg_bit));
}
/*************************************************
Functionu8 RtccClearMsgApp()
DescriptionMSGǰǷڻԾ״̬ÿһСʱжһεĽӿڣݴ
Inputclear_bit
 * 0״̬壬ȱʡ
 * 1״̬壬ȱʡ
 * 2ʱʱ䵽MSG
 * 3Զݴʱ䵽MSG
 * 4УʱڵݴԾmsg
 * 5˳ŵMSG
 *  0,1,2,3,4,5
Output
Returnvoid
Others:
 *************************************************/
void RtccClearMsgApp(Rtcc_MsgTypeDef clear_bit)
{
    s_g_rtcc_msg &= ~(1 << clear_bit);
}

void RtccSetMsgApp(Rtcc_MsgTypeDef set_bit)
{
    s_g_rtcc_msg |= (1 << set_bit); 
}

/****************************************************************
Function:    void RtccAppCheckMiJi(DateTime alarm_time)
Description:  ѯܼϱÿ5minһ
Input:
Return:
Others:

 *****************************************************************/
void RtccAppCheckMiJi(DateTime alarm_time)  //ÿ5minһ
{
	To_u32_Rtcc  miji_begin_date, miji_begin_time, miji_end_date;
	u8 miji_now_time , miji_begin_time_hex; u32 temp_value = 0;
	
	miji_begin_date.rtcc_u32 = FrameCheckParaApp(FramePara_ReportStartDMY);  //ܼϱʼʱbcd
	miji_begin_time.rtcc_u32 = FrameCheckParaApp(FramePara_ReportStartSMH);  //ܼϱʼʱʱbcd
	miji_end_date.rtcc_u32 = FrameCheckParaApp(FramePara_ReportEndSMH);   //ܼϱʱbcd
	temp_value = (alarm_time.s.year<<16) | (alarm_time.s.month<<8) | (alarm_time.s.day) ;
	
	if((miji_begin_date.rtcc_u32 <= temp_value) && (miji_end_date.rtcc_u32 >= temp_value))  //ڿʼںͽ֮ڣգ
	{
		u16 tmpi =0;	
		if(miji_begin_time.rtcc_u8[0] <= alarm_time.s.hour) //ֻжϵСʱ̶00֡
		{	
			if((miji_begin_time.rtcc_u8[0] == alarm_time.s.hour) && (0 == alarm_time.s.minute))  //տʼ棬buf
			{
				//洢buf			
				for (tmpi = 0;tmpi < 384;tmpi++)
				{
					miji_collect_buf[tmpi] = 0;
					date_remember = 0;
				}
				old_total_flow.gp22_u32 = Gp30CheckDataApp(2);	//ܼɼʼֵ			
			}
			else
			{
				miji_now_time = (alarm_time.s.hour >> 4)*10 + (alarm_time.s.hour & 0x0F);//תΪ16ƱȽ
				miji_begin_time_hex = (miji_begin_time.rtcc_u8[0] >> 4)*10 + (miji_begin_time.rtcc_u8[0] & 0x0F);
				if((miji_begin_time_hex + 4) >= miji_now_time)  //ܼϱʱ
				{
					//ܼϱ洢				
					new_total_flow.gp22_u32 = Gp30CheckDataApp(2);
					miji_date.datas = (u16)((new_total_flow.gp22_float - old_total_flow.gp22_float)*10);
					miji_collect_buf[date_remember] = miji_date.datas_map.data0;
					miji_collect_buf[date_remember+1] = miji_date.datas_map.data1;
					miji_collect_buf[date_remember+2] = 0;
					miji_collect_buf[date_remember+3] = 0;
					old_total_flow.gp22_u32 = new_total_flow.gp22_u32;
					date_remember = date_remember +4;
					if(384 == date_remember )
					{
						date_remember = 384;
					}
				}
				if(((miji_begin_time_hex + 4) == miji_now_time) && (0 == alarm_time.s.minute)) //ܼϱʱ
				{
					if(date_remember >192)
					{
						date_remember = date_remember -192; 
					}
					else
					{
						date_remember =0;
					}
					for (tmpi = 0;tmpi < 192;tmpi++)
					{
						miji_collect_send_buf[tmpi] = miji_collect_buf[date_remember+tmpi];
					}	
					for (tmpi = 0;tmpi < 384;tmpi++)
					{
						miji_collect_buf[tmpi] = 0;//BUF
					}	
					date_remember = 0;				
				}
		    }
		}
	    RtccSetMsgApp(RtccMsg_MiJiCaiJi);//s_g_rtcc_msg |= BIT1; //ܼɼʱڣʼ-գ4hɼMSG
	}
	else
	{
	    RtccClearMsgApp(RtccMsg_MiJiCaiJi);//s_g_rtcc_msg &= ~BIT1;
	}
}
/*************************************************
Functionu32 RtccGetWorkHourApp()
Descriptionȡۼʱ
Inputvoid
Outputvoid
Returnvoid
Others:
 *************************************************/
u32 RtccGetWorkHourApp(void)
{
    return Sys_data_object.ee_data.data.work_hour;
}
/*************************************************
FunctionGp30CheckJianGeDataApp(u8 *addr)
Descriptionȡµܼ
Inputvoid
Outputvoid
Returnvoid
Others:
 *************************************************/
void Gp30CheckMiJiDataApp(u8 **addr)
{    
    *addr = miji_collect_send_buf;
}
/*************************************************
FunctionGp30CheckJianGeDataApp(u8 *addr)
Descriptionȡµļ
Inputvoid
Outputvoid
Returnvoid
Others:
 *************************************************/
void Gp30CheckJianGeDataApp(u8 **addr)
{
    *addr = 0;//jiange_collect_send_buf;
}


#ifdef	__cplusplus
}
#endif


