/************************************************************************************
 * @Copyright (c)    :(C)2017, Qindao ieslab Co., Ltd
 * @FileName   	     :nb_driver_bc25.h
 * @Author           :QDIES PLATFORM TEAM
 * @Version          :V1.0
 * @Date             :2020-8-13
 * @Description     :
 ************************************************************************************/

#ifndef __NB_DRIVER_BC28_H
#define	__NB_DRIVER_BC28_H


#include "sys_config.h"
#ifdef NB_MODULE_BC28
#include "type.h"
#include <string.h>
/*----ú궨 AT_ORDER_SET ָĸָ--*/
//#define M_5310_N    0  //M5310  ָͨ
//#define M_5310_A    1  //M5310A ָ
//#define AT_ORDER_SET  M_5310_A 
/*------Ϊ˼򻯳 ʱûкϳɵһ----------*/


/*-------ģ¼IPʾʽ---
 *----IP_PORT       IPʽ
 *----DOMAIN_NAME   ʽ  Ĭģʽ
 *----BOOTSTRAP_ENABLE ģʽ 0-ģʽ  1-ģʽ
 *----ģʽ IP183.230.40.40:5683   :nbiotacc.heclouds.com:5683 
 *----ģʽ IP183.230.40.39:5683   :nbiotbt.heclouds.com:5683
 -----------------------------------*/
//#define IP_PORT_TYPE     0
//#define DOMAIN_NAME_TYPE 1  
//#define SEVER_IP_TYPE  DOMAIN_NAME_TYPE
//#define BOOTSTRAP_ENABLE 0


/*--------------------------------------*/

/*-----ǷGSMУʱ--------
 * 1---   Ĭϴ
 * 0---ر
 */

/*------------------------------------*/
  
  
/*-----÷ǷACK--------
 * 1---
 * 0---ر  ĬϹر  
 */ 
#define SEND_ACKID_ENABLE 0
/*------------------------------------*/

#if (HARDWARE_VERSION==0x14)//Ǳ
#define RSTN_NB_PORT    (GpioPortF)
#define RSTN_NB_PIN     (GpioPin0)

#define BAT_NB_PORT     (GpioPortE)
#define BAT_NB_PIN      (GpioPin4)

#define PWR_NB_PORT     (GpioPortF)
#define PWR_NB_PIN      (GpioPin1)

#define NB_PSM_WAKE_PORT  (GpioPortA)
#define NB_PSM_WAKE_PIN   (GpioPin2)

//PSM 1.8Vѹ ADC_IN5
#define PSM_CHECK_CHANNEL     5  //ADͨ
#define PSM_CHECK_NUM         3  //ת
#define PSM_CHECK_INTERVAL    100

#elif (HARDWARE_VERSION==0x18)//ԲǱ
#define RSTN_NB_PORT    (GpioPortE)
#define RSTN_NB_PIN     (GpioPin4)

#define BAT_NB_PORT     (GpioPortE)
#define BAT_NB_PIN      (GpioPin5)

#define PWR_NB_PORT     (GpioPortE)
#define PWR_NB_PIN      (GpioPin2)

#define NB_PSM_WAKE_PORT  (GpioPortE)
#define NB_PSM_WAKE_PIN   (GpioPin3)
#endif
#define RSTN_NB_LOW()    Gpio_WriteOutputIO(RSTN_NB_PORT, RSTN_NB_PIN, GPIO_PIN_SET)
#define RSTN_NB_HIG()    Gpio_WriteOutputIO(RSTN_NB_PORT, RSTN_NB_PIN, GPIO_PIN_RESET) //ߵƽλ

#define BAT_NB_DISABLE() Gpio_WriteOutputIO(BAT_NB_PORT, BAT_NB_PIN, GPIO_PIN_RESET)
#define BAT_NB_ENABLE()  Gpio_WriteOutputIO(BAT_NB_PORT, BAT_NB_PIN, GPIO_PIN_SET)

#define PWR_NB_LOW()     Gpio_WriteOutputIO(PWR_NB_PORT, PWR_NB_PIN, GPIO_PIN_SET)
#define PWR_NB_HIG()     Gpio_WriteOutputIO(PWR_NB_PORT, PWR_NB_PIN, GPIO_PIN_RESET)

#define NB_PSM_WAKE_LOW()    Gpio_WriteOutputIO(NB_PSM_WAKE_PORT , NB_PSM_WAKE_PIN, GPIO_PIN_SET)
#define NB_PSM_WAKE_HIG()    Gpio_WriteOutputIO(NB_PSM_WAKE_PORT , NB_PSM_WAKE_PIN, GPIO_PIN_RESET) //ߵƽλ


//ѯ״̬Ϣ
#define TASK_BUSY                               0                   //BUSY״̬
#define TASK_IDLE                               1                   //IDLE״̬

//ݷ
#define NBIOT_ING                                0xA2                //
#define NBIOT_ONLINE                             0xA3                //NBIOT
#define NBIOT_SUCCESS                            0xA4                //ͳɹ
#define NBIOT_ERROR                              0xA5                //ʧ

//ѯCSQ
#define CSQ_ING                                 0xA5                //ѯ
#define CSQ_SUCCESS                             0xA6                //ѯɹ
#define CSQ_ERROR                               0xA7                //ѯʧ

//ѯSNR
#define ECL_SNR_ING                                 0xA5                //ѯ
#define ECL_SNR_SUCCESS                             0xA6                //ѯɹ
#define ECL_SNR_ERROR                               0xA7                //ѯʧ

//ȡUDP
#define QIRD_ING                                 0xAA                //ѯ
#define QIRD_SUCCESS                             0xAB                //ѯɹ
#define QIRD_ERROR                               0xAC                //ѯʧ 
//̼
#define FRIMWARE_UPDATE_ING                                 0xA5                //ѯ
#define FRIMWARE_UPDATE_SUCCESS                             0xA6                //ѯɹ
#define FRIMWARE_UPDATE_ERROR                               0xA7                //ѯʧ

//ѯICCID
#define ICCID_ING                               0xA5                //ѯ
#define ICCID_SUCCESS                           0xA6                //ѯɹ
#define ICCID_ERROR                             0xA7                //ѯʧ
#define ICCID_LEN                               0x14                //

  
//ѯRSRP
#define RSRP_ING                               0xA5                //ѯ
#define RSRP_SUCCESS                           0xA6                //ѯɹ
#define RSRP_ERROR                             0xA7                //ѯʧ
#define RSRP_LEN                               0x14                //
  
//
#define TASK_FAIL                               0xA8
#define TASK_SUCCESS                            0xA9
#define TASK_INIT                               0xB0

//ģʽ
#define ONLINE_MODE                             0xB1                //NBIOT
#define SEND_MODE                               0xB2                //NBIOT
#define READ_CSQ                                0xB3                //NBIOTźֵ
#define READ_ICCID                              0xB4                //NBIOTCCID
#define NO_NBIOT_TASK                            0xB5                //ûNBIOT
#define READ_ECL_SNR                            0xB6                //ûNBIOT

//NBIOT״̬
#define NB_ON_LINE                           0x01                //
#define NB_OFF_LINE                          0x00                //

#define CONNECT_ON_LINE                      0x01            
#define CONNECT_OFF_LINE                     0x00            

//ģʽ
#define NBIOT_ALWAYS_ON_LINE_MODE                0x81                //һֱģʽ
#define NBIOT_TIME_ON_LINE_MODE                  0x80                //׶һֱģʽģʽ

//NBIOTԭ
#define NBIOT_OFFLINE_CLEAR                      0x00                //ԭ
#define NBIOT_OFFLINE_PARA_CHANGE                0x01                //
#define NBIOT_OFFLINE_STATION_CUT                0x02                //վ
#define NBIOT_OFFLINE_SPARE_STATION_START        0x03                //վ
#define NBIOT_OFFLINE_SPARE_STATION_CLOSE        0x04                //رձվ
#define NBIOT_OFFLINE_OPEN_APN                   0x05                //APN

//״̬е״̬
#define NBIOT_S_IDLE                             0                   //״̬
#define NBIOT_POWER_INIT                         1                   //NBIOTģʼ
#define NBIOT_NET_OPEN                           2                   //
//#define NBIOT_COAPorONENET_OPEN                   3                   //TCP
//#define NBIOT_COAPorONENET_DATA_SEND             4                   //
#define NBIOT_TCP_CLOSE                          5                   //رTCP
#define NBIOT_NET_CLOSE                          6                   //رNBIOT
#define NBIOT_POWER_OFF                          7                   //ģػ
#define NBIOT_HEART_FRAME                        8                   //֡
#define NBIOT_READ_CSQ                           9                   //źֵ
#define NBIOT_READ_ICCID                         10                  //ICCID
#define NBIOT_DATA_REV                           11                  //NBIOTݽ
#define NBIOT_READ_ECL_SNR                       12                  //ȡRSRP  
#define NBIOT_READ_RCV                           13  
#define NBIOT_READ_DATE_TIME                     14
#define NBIOT_READ_UDP_DATA                      15
#define NBIOT_UDP_OPEN                           16                   //UDP
#define UDP_DATA_SEND                            17                   //UDP

#define NBIOT_TCP_OPEN                           18                   //TCP
#define NBIOT_DATA_SEND                          19                   //
#define NBIOT_REV_ACK                            20
#define NBIOT_PSM_WAKEUP                         21
#define NBIOT_PSM_SLEEP                          22
//ʼ״̬״̬
#define S_START					            0                   //ʼ״̬
#define S_POWER_ON_LOW                      1                   //ƽأ--
#define S_POWER_ON_WAIT                     2                   //ƽأ--
#define S_ATS					            3                   //ͳʼATָ
#define S_ATS_R				                4                   //жϳʼATָ״̬
#define S_CHECK_CGATT			            5                   //Query whether network is activated
#define S_CHECK_CGATT_WAIT        		    6                   //Check whether network is activated
#define S_CHECK_CEREG				        7                   //ͲѯעϢ ATָ
#define S_CHECK_CEREG_WAIT        	        8                   //жϲѯעϢ ATָ
#define S_CHECK_CSCON				        9                   //Query the signaling connection status
#define S_CHECK_CSCON_WAIT        	        10                  //Check the signaling connection status

//NBIOT״̬״̬
#define S_CHECK_CIMI			        1                   //ͲѯIMSI ATָ
#define S_CHECK_CIMI_WAIT        		2                   //жϲѯIMSI ATָ״̬
#define S_AT_CGDCONT                    3                   //APN
#define S_AT_CGDCONT_R                  4                   //жAPNǷóɹ

//PSM״̬
typedef enum{
	PSM_WKUPSTA_IDLE=0,
	PSM_WKUPSTA_START,
	PSM_WKUPSTA_EINT_LOW,
	PSM_WKUPSTA_EINT_HIGH,
	PSM_WKUPSTA_QLWEVTIND6,
	PSM_WKUPSTA_QSCLK0,
	PSM_WKUPSTA_QSCLK0_R,
	PSM_WKUPSTA_NCDP_CK,
	PSM_WKUPSTA_NCDP_CK_R,
	PSM_WKUPSTA_NPING,
	PSM_WKUPSTA_NPING_R,
	PSM_WKUPSTA_NUESTATS,
	PSM_WKUPSTA_NUESTATS_R,
	
	PSM_WKUPSTA_UPDATE,
	PSM_WKUPSTA_UPDATE_R,
	
	PSM_WKUPSTA_WAKE_SUCCESS,
	PSM_WKUPSTA_WAKE_FAIL,
}TYP_PSM_WAKEUP_STATE;

//PSM״̬
typedef enum{
	PSM_SLPSTA_IDLE=0, 	
	PSM_SLPSTA_START,
	PSM_SLPSTA_CPSMS1_R,
	PSM_SLPSTA_WAIT,
	PSM_CHECK_START,
	PSM_CHECK_WAIT,
}TYP_PSM_SLEEP_STATE;

//PSM״̬
typedef enum{
	PSM_STATE_OUT=0, 	
	PSM_STATE_WAKE,
	PSM_STATE_SLEEP,   	
}TYP_PSM_STATE;

//״̬
#define S_AT_NSORF                              1                   //ȡ
#define S_AT_NSORF_R                            2                   //жǷȡݳɹ

//رTCP/IP״̬״̬
#define S_AT_NSOCL                              1                   //رTCP/IP
#define S_AT_NSOCL_R                            2                   //жTCP/IPǷرճɹ

//رNBIOT״̬״̬
#define S_POWER_OFF_START                        0
#define S_AT_NETCLOSE                            1                   //رNBIOT
#define S_AT_NETCLOSE_R                          2                   //жNBIOTǷرճɹ
#define S_AT_QPOWD							     3
#define S_AT_QPOWD_R						     4
#define S_AT_CFUN0                               7
#define S_AT_CFUN0_R                             8
#define S_AT_NCSEARFCN                           9
#define S_AT_NCSEARFCN_R                        10
#define S_AT_CFUN1                              11
#define S_AT_CFUN1_R                            12
#define S_POWER_OFF                             13
#define S_POWER_OFF_WAIT                        14

#define S_AT_MIPLCLOSE                          15                   //رonenet
#define S_AT_MIPLCLOSE_R                        16                   //жonenetǷرճɹ
#define S_AT_MIPLDELOBJ                         17                   //жonenetǷرճɹ
#define S_AT_MIPLDELOBJ_R                       18                   //жonenetǷرճɹ
#define S_AT_MIPLDEL                            19                   //жonenetǷرճɹ
#define S_AT_MIPLDEL_R                          20                   //жonenetǷرճɹ

//ػ״̬״̬
#define S_AT_COPS                               24                  //жǷעɹ
#define S_AT_COPS_R                             25                  //͹ػָ
//#define S_POWER_OFF                           26
//#define S_POWER_OFF_WAIT                      27

//ȡźֵ״̬
#define S_AT_CSQ                                28
#define S_AT_CSQ_R                              29
#define CSQ_READ_NUM                            4                    //źֵȡ
//ȡECLSNR
#define S_AT_ECL                              30
#define S_AT_ECL_R                            31

//ȡUDP
#define S_AT_QIRD                                1
#define S_AT_QIRD_R                              2

//վ״̬
#define OPEN_SPARE_STATION                      0x01
#define CLOSE_SPARE_STATION                     0x00

//ͨģʽѡ
#define SIM_CARD_TELECOM                        0x00 //ſ
#define SIM_CARD_MOBILE                         0X01 //ƶ
//
//OnenetConnectMachineʹõ״̬
#define S_ONENET_CONNECT_IDLE	      0                   
#define S_ONENET_CONNECT_START	      1 
#define S_ONENET_MIPLCONFIG           2
#define S_ONENET_MIPLCONFIG_R         3
#define S_ONENET_MIPLCONFIG_CK        4
#define S_ONENET_MIPLCONFIG_CK_R      5
#define S_ONENET_MIPLCREATE           6
#define S_ONENET_MIPLCREATE_R         7
#define S_ONENET_MIPLADDOBJ           8
#define S_ONENET_MIPLADDOBJ_R         9
#define S_ONENET_MIPLOPEN             10
#define S_ONENET_MIPLOPEN_R           11
#define S_ONENET_MIPLDISCOVER         12
#define S_ONENET_MIPLDISCOVER_R       13
//#define S_ONENET_ECL                  14
//#define S_ONENET_ECL_R                15
//#define S_ONENET_CCLK                 16
//#define S_ONENET_CCLK_R               17
//#define S_ONENET_Wait                 18

//ͨЭ
#define NBIOT_CONNECT_COAP  0
#define NBIOT_CONNECT_UDP1  1
#define NBIOT_CONNECT_UDP2  2
//******************************* ṹ嶨*************************************
//ռ
#ifndef  APN_SIZE
#define APN_SIZE                                32
#endif 
typedef struct
{
    u8 *work_mode; //ģʽһֱģʽʱģʽ
    u8 *ip; //IP
    u8 *spare_ip; //IP
    u8 *port; //˿ں
    u8 *spare_port; //ö˿ں
    u8 *apn; //APN
} CFIG_PARA;

//NBIOTϢ

typedef union
{
    struct
    {
        u8 para_change : 1; //ı
        u8 station_close : 1; //վ
        u8 open_spare_station : 1; //վ
        u8 close_spare_station : 1; //رձվ
        u8 apn_open : 1; //APN
        u8 rev_data : 1; //յ
    } s;
    u8 info;
} NBIOT_MSG;

//NBIOTز

typedef struct
{
    CFIG_PARA cfig_para; //ò
    u8 csq; //źֵ
    u8 net_state; //״̬
    u8 offline_reason; //ԭ
    u8 Telecom; //Ӫ
    u8 spare_station; //վ
	u8 coap_state;
	u8 udp1_state;
	u8 udp2_state;
    char imei[16];//IMEIΪ15 BIT һֽΪ \0
    char imsi[16];//IMSIΪ15 BIT һֽΪ \0
    char iccid[21];//ICCIDΪ20λ ֻߴдַ 
} NBIOT_PARA;

//ݷ

typedef struct
{
    u8 *state; //ָmsg
    u8 *buf; //ָ
    u16 len; //ͳ
} NBIOT_SEND_DATA;


//******************************* ⲿ***************************************
extern NBIOT_PARA Nbiot_Para;
extern NBIOT_MSG Nbiot_Msg;

//******************************* ⲿӿں***********************************
void NbiotOnlineTask(u8 *state);
void NbiotSendTask(u8 *addr, u16 len, u8 send_type,u8 *state);
void NbiotUdpOpenTask(void);
void NbiotReadECLSNRTask(u8 *state);
void NB_NetConnectStart(unsigned char* temp_ip, u16 temp_port, u8 connect_type);
u8 ConncetIfOnline(u8 connect_type);
void StartNbiotSendData(void);
u32 sys_get_net_state(void);
void sys_set_net_state(u8 state,u8 data);
u16 get_Send_AckID(void);

u8 NbiotIfIdle(void);
u8 NbiotIfOnline(void);
u8 NbiotIfSleep(void);
void NbiotPreSleep(void);
void NbiotWakeSleep(void);

void NbiotGetCcidTask(u8 **ccid, u8 *state);
void NbiotMainMachine(void);

u8 If_NB_Poweron(void);
void StartPowerOffTask(void);
void set_ip_port(void);
void NbForcePowerOff(void);
u8 GetNbiotSendType(void);
//u8 UdpIfOnline(void);
TYP_PSM_STATE getPsmState(void);
u8 checkPsmEnterMsg(void);
void clearPsmEnterMsg(void);
void NbiotPsmWakeupTask(void);
void NbiotPsmSleepTask(void);
void NbiotPsmCheckTask(void);
//ʼ״̬״̬
#define S_INIT_POWER_ON			     0                   //ģ͵
#define S_INIT_RESET_LOW             1                   //ʼλģ
#define S_INIT_RESET_HIGH            2                   //ģɸλ
#define S_INIT_POWER_ON_WAIT         3                   //ȴģע
#define S_INIT_ATS					 4                   //ͳʼATָ
#define S_INIT_ATS_R				 5                   //жϳʼATָ״̬
#define S_INIT_CMEE                  6                   //ERRORʾ
#define S_INIT_CMEE_R                7                   //ERRORʾ״̬
#define S_TCP_CPSMS                  8                   //رPSMģʽ
#define S_TCP_CPSMS_R                9
#define S_TCP_NPTWEDRXS              10                  //رeDRXģʽ
#define S_TCP_NPTWEDRXS_R            11
#define S_INIT_ASK_IMEI				 12                   //ѯIMEI
#define S_INIT_ASK_IMEI_R			 13                   //ѯIMEI״̬
#define S_INIT_ASK_CIMI				 14                   //ѯCIMI
#define S_INIT_ASK_CIMI_R			 15                   //ѯCIMI״̬
#define S_INIT_ASK_CSQ				 16                  //ѯCSQ
#define S_INIT_ASK_CSQ_R			 17                  //ѯCSQ״̬
#define S_INIT_ASK_CEREG			 18                  //ѯCEREG
#define S_INIT_ASK_CEREG_R			 19                  //ѯCEREG״̬
#define S_INIT_ASK_CGATT			 20                  //ѯCGATT
#define S_INIT_ASK_CGATT_R			 21                  //ѯCGATT״̬
//#define S_INIT_AT_CCLK               22                  //ѯʱ
//#define S_INIT_AT_CCLK_R             23                  //ѯʱ䷵״̬
#define S_INIT_ASK_ICCID             24                  //ѯSIMICCID
#define S_INIT_ASK_ICCID_R           25                  //ѯSIMICCID״̬
#define S_INIT_AT_CGDCONT             26                  //ѯSIMICCID
#define S_INIT_AT_CGDCONT_R           27                  //ѯSIMICCID״̬
//#define S_INIT_AT_CFUN0               28                  //Ƶ
//#define S_INIT_AT_CFUN0_R             29                  //ѯƵ״̬
//#define S_INIT_AT_CFUN1               30                  //Ƶ
//#define S_INIT_AT_CFUN1_R             31                  //ѯƵ״̬
#define S_INIT_AT_READ_APN            32                 //ѯSIMICCID
#define S_INIT_AT_READ_APN_R          33                  //ѯSIMICCID״̬

#define S_INIT_PWRKEY_LOW             34                   //ʼλģ
#define S_INIT_PWRKEY_HIGH            35                   //ģɸλ

#define S_INIT_SET_NCFG              36                   //lifetime ƽ̨˵
#define S_INIT_SET_NCFG_R            37                   //lifetime ƽ̨˵
#define	S_INIT_ASK_NUESTATS          38
#define	S_INIT_ASK_NUESTATS_R        39
#define	S_INIT_ASK_CCLK              40
#define	S_INIT_ASK_CCLK_R            41

//TCP״̬
//#define S_COAP_CONNECT_START	      0                   //
//#define S_TCP_CONNECT_DEL           1                 //ɾǰ

//#define S_TCP_CONNECT_START	        0                   //ģ͵

//#define S_UDP_CONNECT_START           0       
#define SEND_TYPE_COAP                0
#define SEND_TYPE_UDP1                1
#define SEND_TYPE_UDP2                2
#define SEND_TYPE_TCP1                3
//CoapConnectMachine
#define S_COAP_CONNECT_START	      0                   
#define S_COAP_NCDP                   1
#define S_COAP_NCDP_R                 2
#define S_COAP_NCDP_CK                3
#define S_COAP_NCDP_CK_R              4
//#define S_COAP_Wait                   5
//#define S_COAP_ECL                    6 //ȡECLSNR
//#define S_COAP_ECL_R                  7
//#define S_COAP_CCLK                   8 //ѯʱ
//#define S_COAP_CCLK_R                 9 //ѯʱ䷵״̬
////UdpConnectMachine
//#define S_UDP_CONNECT_START           0  
//#define S_UDP_QIOPEN                   1
//#define S_UDP_QIOPEN_R                 2
//#define S_UDP_NCDP_CK                  3
//#define S_UDP_NCDP_CK_R                4
//#define S_UDP_CCLK                     5
//#define S_UDP_CCLK_R                   6
//#define S_UDP_NUESTATS                 7
//#define S_UDP_NUESTATS_R               8
//#define S_UDP_Wait                     9

//UDP״̬
typedef enum{
	S_UDP_CONNECT_IDLE=0,
	S_UDP_CONNECT_START,
	S_UDP_CONNECT_NSOCR,
	S_UDP_CONNECT_NSOCR_R,
    S_UDP_CONNECT_NSONMI,
    S_UDP_CONNECT_NSONMI_R
}TYP_UDP_CONNECT;

//UDP״̬
typedef enum{
	S_UDP_SEND_IDLE=0,  
	S_UDP_SEND_START,   
	S_UDP_SEND_NSOFT,	
	S_UDP_SEND_NSOFT_R
}TYP_UDP_SEND;

//onenetָ
#define S_TCP_MIPLCONFIG            1
#define S_TCP_MIPLCONFIG_R			2
#define S_TCP_MIPLCREATE            3                   //õ¼Ϣ
#define S_TCP_MIPLCREATE_R          4                   //ɾǰӷ״̬
#define S_TCP_MIPLADDOBJ            5                   //ƶ
#define S_TCP_MIPLADDOBJ_R          6                   //ƶ󷵻״̬
#define S_TCP_MIPLDISCOVERRSP       7                   //Դ
#define S_TCP_MIPLDISCOVERRSP_R     8                 //Դ״̬
#define S_TCP_MIPLOPEN 				9
#define S_TCP_MIPLOPEN_R 			10
#define S_TCP_WAIT_DISCOVER     	11	
#define S_TCP_ACK_DISCOVER     		12
//
#define S_TCP_CONNECT_MIPLCONF      12                   //õ¼Ϣ
#define S_TCP_CONNECT_MIPLCONF_R    13                   //õ¼Ϣ״̬

//״̬
#define S_SEND_START     0
#define S_SEND_ACK       1
#define S_SEND_ACK_R     2
#define S_SEND_DATA      3
#define S_SEND_DATA_R    4


//ONENET ӦMIPLWRITE״̬
#define S_ONENET_ACKREV_IDLE          0
#define S_ONENET_ACKREV_START	      1                 
#define S_ONENET_REPLY_REV_ACKID	  2 //Ӧյ
#define S_ONENET_REPLY_REV_ACKID_R    3 //Ӧյ--ȴӦ*/

//رonenet״̬״̬
//#define S_AT_MIPLCLOSE                           1                   //رonenet
//#define S_AT_MIPLCLOSE_R                         2                   //жonenetǷرճɹ
//#define S_AT_MIPLDELOBJ                          3                   //жonenetǷرճɹ
//#define S_AT_MIPLDELOBJ_R                        4                   //жonenetǷرճɹ
//#define S_AT_MIPLDEL                             5                   //жonenetǷرճɹ
//#define S_AT_MIPLDEL_R                           6                   //жonenetǷرճɹ
//#define S_AT_CFUN0                               7
//#define S_AT_CFUN0_R                             8
//#define S_AT_NCSEARFCN                           9
//#define S_AT_NCSEARFCN_R                        10
//#define S_AT_CFUN1                              11
//#define S_AT_CFUN1_R                            12
//#define S_POWER_OFF                             13
//#define S_POWER_OFF_WAIT                        14


#define NUM_AT_ERROR            5			//5 
#define NUM_AT_CMEE_ERROR       5			//5
#define NUM_AT_CIMI_ERROR       5			//5
#define NUM_AT_IMEI_ERROR       5			//5 
#define NUM_AT_ICCID_ERROR      5			//5
#define NUM_AT_CSQ_ERROR        5    
#define NUM_AT_CEREG_ERROR      15//2x15=30
//#define NUM_AT_CGATT_ERROR      50//100s    //20 
#define NUM_AT_CCLK_ERROR       2 

#define NUM_AT_NCDP_ERROR          1
#define NUM_AT_NCDP_CK_ERROR       1

#define NUM_AT_NNMI_ERROR            5			//5
#define NUM_AT_CPSMS_ERROR           5			//5
#define NUM_AT_MIPLDEL_ERROR         5			//5
#define NUM_AT_MIPLCONF_ERROR        2//5Ϊ2			//5
#define NUM_AT_MIPLCREATE_ERROR      5			//5
#define NUM_AT_MIPLADDOBJ_ERROR      5			//5
#define NUM_AT_MIPLDISCOVERRSP_ERROR 2//5Ϊ2
#define NUM_AT_ECL_ERROR             2			//5

#define NUM_AT_MIPLNOTIFY_ERROR      5			//5
#define NUM_AT_MIPLOPEN_ERROR        2//5	//5Ϊ2		//5
#define NUM_AT_MIPLWRITE_ERROR       5			//5
#define NUM_AT_MIPLCLOSE_ERROR       5			//5
#define NUM_M5310_RESTART            5			//5
#define NUM_AT_CFUN_ERROR            3			//5
#define NUM_AT_NCSEARFCN_ERROR       3			//5
#define NUM_AT_NPTWEDRXS_ERROR       3			//5
#define NUM_AT_NSONMI_ERROR          3			//5

#define AT_COMMAND_SEND_INTERVAL_TIME 300   //mS
#define AT_COMMAND_RECEIVE_WAIT_TIME  1000  //mS

#endif	

#endif	



